<template>
  <div>
    <el-form ref="form" :model="form" :rules="rules" label-width="80px">
      <el-form-item label="公司名称" prop="name">
        <el-input
          v-model="form.name"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="统一信用代码" prop="creditCode">
        <el-input v-model="form.creditCode" placeholder="请输入统一信用代码" />
      </el-form-item>
      <el-form-item label="通讯地址" prop="address">
        <el-input
          v-model="form.address"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="网址" prop="webSite">
        <el-input v-model="form.webSite" placeholder="请输入网址" />
      </el-form-item>
      <el-form-item label="公司简介" prop="companyDesc">
        <el-input
          v-model="form.companyDesc"
          type="textarea"
          placeholder="请输入内容"
        />
      </el-form-item>
      <el-form-item label="联系人姓名" prop="contactName">
        <el-input v-model="form.contactName" placeholder="请输入联系人姓名" />
      </el-form-item>
      <el-form-item label="联系人职位" prop="contactPosition">
        <el-input
          v-model="form.contactPosition"
          placeholder="请输入联系人职位"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="cancel">取 消</el-button>
    </div>
  </div>
</template>

<script>
import {
  listCompanyApply,
  getCompanyApplyByUid,
  delCompanyApply,
  addCompanyApply,
  updateCompanyApply,
  exportCompanyApply,
} from "@/api/tester/CompanyApply";

export default {
  name: "CompanyApply",
  components: {},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企业认证申请表格数据
      CompanyApplyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 审核时间时间范围
      daterangeAuditTime: [],
      // 创建时间时间范围
      daterangeCreateTime: [],
      // 更新时间时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        creditCode: null,
        address: null,
        webSite: null,
        companyDesc: null,
        contactName: null,
        contactPosition: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "公司名称不能为空", trigger: "blur" },
        ],
        creditCode: [
          { required: true, message: "统一信用代码不能为空", trigger: "blur" },
        ],
        address: [
          { required: true, message: "通讯地址不能为空", trigger: "blur" },
        ],
        webSite: [{ required: true, message: "网址不能为空", trigger: "blur" }],
        companyDesc: [
          { required: true, message: "公司简介不能为空", trigger: "blur" },
        ],
        contactName: [
          { required: true, message: "联系人姓名不能为空", trigger: "blur" },
        ],
        contactPosition: [
          { required: true, message: "联系人职位不能为空", trigger: "blur" },
        ],
      },
    };
  },
  created() {
    this.getCompanyApplyByUserID(this.$route.query.userId);
  },
  methods: {
    /** 查询企业认证申请列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeAuditTime && "" != this.daterangeAuditTime) {
        this.queryParams.params["beginAuditTime"] = this.daterangeAuditTime[0];
        this.queryParams.params["endAuditTime"] = this.daterangeAuditTime[1];
      }
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listCompanyApply(this.queryParams).then((response) => {
        this.CompanyApplyList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        applyId: null,
        name: null,
        creditCode: null,
        address: null,
        webSite: null,
        companyDesc: null,
        contactName: null,
        contactPosition: null,
        createTime: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeAuditTime = [];
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.applyId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企业认证申请";
    },
    /** 加载审核页面数据操作 */
    getCompanyApplyByUserID(userId) {
      getCompanyApplyByUid(userId).then((response) => {
        // console.log(response.data);
        if (response.data) {
          this.form = response.data;
        } else {
          this.materialServerAddr = response.msAddr;
          this.allFileGetFlag = true;
        }
        this.open = true;
        this.title = "修改企业认证申请";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.applyId != null) {
            updateCompanyApply(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCompanyApply(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const applyIds = row.applyId || this.ids;
      this.$confirm(
        '是否确认删除企业认证申请编号为"' + applyIds + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delCompanyApply(applyIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有企业认证申请数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportCompanyApply(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
  },
};
</script>
